import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.imageio.*;

/**
 * plNX
 */
public class MGPanel extends JPanel {

	/** }EXA_v^ */
	private		MGMouseAdapter		mgma		= null;

	/** sRsRn}[W */
	private		int					px			= 0;
	/** sRsRn}[W */
	private		int					py			= 0;

	/** W */
	private		int					mx			= 350;
	/** W */
	private		int					my			= 200;

	/** sRsRn}[ */
	private		BufferedImage[]		imagePHs	= null;
	/** sRsRn}[ */
	private		int					ph			= 0;

	/**  */
	private		BufferedImage[]		imageMs		= null;
	/**  */
	private		int					m			= 0;
	/** ̎ */
	private		int					timeM		= 0;

	/** ^C}[ */
	private		java.util.Timer		timerThis	= null;

	/**
	 * RXgN^
	 */
	public MGPanel() {

		// X[p[NXĂяo
		super();

		try{

			// plTCY
			super.setPreferredSize(new Dimension(800, 600));
			// CAEgݒ
			super.setLayout(null);

			// }EXA_v^𐶐
			mgma = new MGMouseAdapter();
			// plɃ}EXXi[ǉ
			super.addMouseListener(mgma);
			super.addMouseMotionListener(mgma);

			// sRsRn}[ǂݍ
			imagePHs = new BufferedImage[2];
			InputStream isPH00 = this.getClass().getResourceAsStream("PH00.gif");
			imagePHs[0] = ImageIO.read(isPH00);
			isPH00.close();

			InputStream isPH01 = this.getClass().getResourceAsStream("PH01.gif");
			imagePHs[1] = ImageIO.read(isPH01);
			isPH01.close();

			// ǂݍ
			imageMs = new BufferedImage[2];
			InputStream isM00 = this.getClass().getResourceAsStream("M00.gif");
			imageMs[0] = ImageIO.read(isM00);
			isM00.close();

			InputStream isM01 = this.getClass().getResourceAsStream("M01.gif");
			imageMs[1] = ImageIO.read(isM01);
			isM01.close();

			// ^C}[𐶐
			timerThis = new java.util.Timer();

			// ^C}[X^[g
			timerThis.scheduleAtFixedRate(new TimerActionTimerTask(), 1000l, 16l);

		}catch(Exception ex){
			ex.printStackTrace();
			JOptionPane.showMessageDialog(this, "ERROR : " + ex.toString());
		}

	} // end MGPanel

	/**
	 * s.
	 */
	public void run(){

		// ĂꍇA
		if(timeM != 0){

			// Ԃ|P
			timeM--;

			// ԂOɂȂ
			if(timeM == 0){

				// V\
				m = 0;

				mx = (int)(Math.random() * 550);
				my = (int)(Math.random() * 450);

			} // end if ԂOɂȂ

		} // end if Ăꍇ

	} // end run

	/**
	 * `惁\bh.
	 * <pre>
	 * yCgKvƂɂ̃\bhĂяo܂B
	 * </pre>
	 */
	public void paint(Graphics g){

		// ʂhԂ
		g.setColor(Color.black);
		g.fillRect(0, 0, 800, 600);

		// `悷
		g.drawImage(imageMs[m], mx, my, 100, 100, this);

		// sRsRn}[`悷
		g.drawImage(imagePHs[ph], px, py, 100, 88, this);

	} // end paint

	/**
	 * }EXA_v^
	 */
	private class MGMouseAdapter extends MouseAdapter {

		/**
		 * }EXꂽɌĂ΂܂
		 */
		public void mousePressed(MouseEvent me){

			// sRsRn}[@
			ph = 1;
			// ꏊL
			px = me.getX() - 100;
			py = me.getY() - 100;

			// Ƃ̓蔻
			if(px > mx - 50 && px < mx + 90 && py > my - 70 && py < my + 60){
				// ꂽ
				m = 1;
				timeM = 30;
			}

		} //  end mousePressed

		/**
		 * }EXꂽɌĂ΂܂
		 */
		public void mouseReleased(MouseEvent me){

			// sRsRn}[グ
			ph = 0;
			// ꏊL
			px = me.getX() - 100;
			py = me.getY() - 100;

		} //  end mouseReleased

		/**
		 * }EXړꂽɌĂ΂܂
		 */
		public void mouseMoved(MouseEvent me){

			// ꏊL
			px = me.getX() - 100;
			py = me.getY() - 100;

		} //  end mouseMoved

		/**
		 * }EXhbOꂽɌĂ΂܂
		 */
		public void mouseDragged(MouseEvent me){

			// ꏊL
			px = me.getX() - 100;
			py = me.getY() - 100;

		} //  end mouseDragged

	} // end MGMouseAdapter

	/**
	 * ^C}[NX.
	 */
	private class TimerActionTimerTask extends TimerTask {

		public void run(){

			// s\bhĂяo
			MGPanel.this.run();

			// `悷
			repaint();

		} // end actionPerformed

	} // end TimerActionTimerTask

}
